// name   : ConfirmMessageBox.cs
// author : Harald Maier
// date   : 21.11.2003
//
//
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version.                                   

using System;

namespace SoaringDotNET.Dialogs
{
	/// <summary>
	/// 
	/// </summary>
    public enum ConfirmResults {Replace, ReplaceAll, Skip, SkipAll, Add, AddAll};

    public class ConfirmMessageBox : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Button buttonAdd;
        private System.Windows.Forms.Button buttonAddAll;
        private System.Windows.Forms.Button buttonReplace;
        private System.Windows.Forms.Label message;
        private System.Windows.Forms.Button buttonReplaceAll;
        private System.Windows.Forms.Button buttonSkipAll;
        private System.Windows.Forms.Button buttonSkip;
        public ConfirmResults Result;

		public ConfirmMessageBox(string message)
		{
			// 
			// TODO: Add constructor logic here
			//
            InitializeComponent();
            this.message.Text = message;
		}

        #region Private Functions
        private void InitializeComponent() {
            this.buttonAdd = new System.Windows.Forms.Button();
            this.buttonAddAll = new System.Windows.Forms.Button();
            this.buttonReplace = new System.Windows.Forms.Button();
            this.buttonReplaceAll = new System.Windows.Forms.Button();
            this.message = new System.Windows.Forms.Label();
            this.buttonSkipAll = new System.Windows.Forms.Button();
            this.buttonSkip = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // buttonAdd
            // 
            this.buttonAdd.Location = new System.Drawing.Point(14, 64);
            this.buttonAdd.Name = "buttonAdd";
            this.buttonAdd.Size = new System.Drawing.Size(75, 23);
            this.buttonAdd.TabIndex = 0;
            this.buttonAdd.Text = "Add";
            this.buttonAdd.Click += new System.EventHandler(this.OnClick);
            // 
            // buttonAddAll
            // 
            this.buttonAddAll.Location = new System.Drawing.Point(107, 64);
            this.buttonAddAll.Name = "buttonAddAll";
            this.buttonAddAll.Size = new System.Drawing.Size(75, 23);
            this.buttonAddAll.TabIndex = 1;
            this.buttonAddAll.Text = "Add All";
            this.buttonAddAll.Click += new System.EventHandler(this.OnClick);
            // 
            // buttonReplace
            // 
            this.buttonReplace.Location = new System.Drawing.Point(200, 64);
            this.buttonReplace.Name = "buttonReplace";
            this.buttonReplace.Size = new System.Drawing.Size(75, 23);
            this.buttonReplace.TabIndex = 2;
            this.buttonReplace.Text = "Replace";
            this.buttonReplace.Click += new System.EventHandler(this.OnClick);
            // 
            // buttonReplaceAll
            // 
            this.buttonReplaceAll.Location = new System.Drawing.Point(293, 64);
            this.buttonReplaceAll.Name = "buttonReplaceAll";
            this.buttonReplaceAll.Size = new System.Drawing.Size(75, 23);
            this.buttonReplaceAll.TabIndex = 3;
            this.buttonReplaceAll.Text = "Replace All";
            this.buttonReplaceAll.Click += new System.EventHandler(this.OnClick);
            // 
            // message
            // 
            this.message.Location = new System.Drawing.Point(8, 16);
            this.message.Name = "message";
            this.message.Size = new System.Drawing.Size(549, 32);
            this.message.TabIndex = 4;
            this.message.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // buttonSkipAll
            // 
            this.buttonSkipAll.Location = new System.Drawing.Point(479, 64);
            this.buttonSkipAll.Name = "buttonSkipAll";
            this.buttonSkipAll.Size = new System.Drawing.Size(75, 23);
            this.buttonSkipAll.TabIndex = 6;
            this.buttonSkipAll.Text = "Skip All";
            this.buttonSkipAll.Click += new System.EventHandler(this.OnClick);
            // 
            // buttonSkip
            // 
            this.buttonSkip.Location = new System.Drawing.Point(386, 64);
            this.buttonSkip.Name = "buttonSkip";
            this.buttonSkip.Size = new System.Drawing.Size(75, 23);
            this.buttonSkip.TabIndex = 5;
            this.buttonSkip.Text = "Skip";
            this.buttonSkip.Click += new System.EventHandler(this.OnClick);
            // 
            // ConfirmMessageBox
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(569, 102);
            this.Controls.Add(this.buttonSkipAll);
            this.Controls.Add(this.buttonSkip);
            this.Controls.Add(this.message);
            this.Controls.Add(this.buttonReplaceAll);
            this.Controls.Add(this.buttonReplace);
            this.Controls.Add(this.buttonAddAll);
            this.Controls.Add(this.buttonAdd);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "ConfirmMessageBox";
            this.ShowInTaskbar = false;
            this.Text = "Attention";
            this.ResumeLayout(false);

        }

        private void OnClick(object sender, System.EventArgs e) {
            if (sender == buttonAdd) {
                Result = ConfirmResults.Add;
            }
            else if (sender == buttonAddAll) {
                Result = ConfirmResults.AddAll;
            }
            else if (sender == buttonReplace) {
                Result = ConfirmResults.Replace;
            }
            else if (sender == buttonReplaceAll) {
                Result = ConfirmResults.ReplaceAll;
            }
            else if (sender == buttonSkip) {
                Result = ConfirmResults.Skip;
            }
            else if (sender == buttonSkipAll) {
                Result = ConfirmResults.SkipAll;
            }

            DialogResult = System.Windows.Forms.DialogResult.OK;
        }
        #endregion
	}
}
