// name   : WaypointDialog.cs
// author : Harald Maier
// date   : 03.08.2003
//
//
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version.                                   

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using SoaringDotNET.Data;

namespace SoaringDotNET.Dialogs
{
	/// <summary>
	/// Summary description for WaypointDialog.
	/// </summary>
	public class WaypointDialog : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Label label1;
        public SoaringDotNET.Controls.CoordEditControl lonEdit;
        public SoaringDotNET.Controls.CoordEditControl latEdit;
        public System.Windows.Forms.TextBox name;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.Button buttonOK;
        private System.Windows.Forms.Button buttonCancel;
        private System.Windows.Forms.Label label4;
        public System.Windows.Forms.TextBox icaoEdit;
        private System.Windows.Forms.Label label5;
        public System.Windows.Forms.TextBox descriptionEdit;
        private System.Windows.Forms.Label label6;
        public System.Windows.Forms.ComboBox typeCombo;
        private System.Windows.Forms.Label label7;
        public System.Windows.Forms.ComboBox countryCombo;
        private System.Windows.Forms.Label label8;
        public System.Windows.Forms.TextBox elevationEdit;
        private System.Windows.Forms.Label label9;
        public System.Windows.Forms.TextBox frequencyEdit;
        public System.Windows.Forms.CheckBox landabeCheck;
        private System.Windows.Forms.Label label10;
        public System.Windows.Forms.TextBox runwayEdit;
        private System.Windows.Forms.Label label11;
        public System.Windows.Forms.TextBox lenghtEdit;
        private System.Windows.Forms.Label label12;
        public System.Windows.Forms.ComboBox surfaceCombo;
        private System.Windows.Forms.Label label13;
        public System.Windows.Forms.TextBox commentEdit;
        private System.Windows.Forms.Label label14;
        public System.Windows.Forms.TextBox shortName;
        public System.Windows.Forms.CheckBox checkBoxHomePoint;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public WaypointDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
            foreach (IdType t in AppContents.waypointTypes) {
                typeCombo.Items.Add(t);
            }
            foreach (IdType t in AppContents.surfaceTypes) {
                surfaceCombo.Items.Add(t);
            }
            foreach (IdType t in AppContents.countryTypes) {
                countryCombo.Items.Add(t);
            }
        }

        #region Protected Functions
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

        #endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(WaypointDialog));
            this.label1 = new System.Windows.Forms.Label();
            this.name = new System.Windows.Forms.TextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.buttonOK = new System.Windows.Forms.Button();
            this.buttonCancel = new System.Windows.Forms.Button();
            this.label4 = new System.Windows.Forms.Label();
            this.icaoEdit = new System.Windows.Forms.TextBox();
            this.label5 = new System.Windows.Forms.Label();
            this.descriptionEdit = new System.Windows.Forms.TextBox();
            this.label6 = new System.Windows.Forms.Label();
            this.typeCombo = new System.Windows.Forms.ComboBox();
            this.label7 = new System.Windows.Forms.Label();
            this.countryCombo = new System.Windows.Forms.ComboBox();
            this.label8 = new System.Windows.Forms.Label();
            this.elevationEdit = new System.Windows.Forms.TextBox();
            this.label9 = new System.Windows.Forms.Label();
            this.frequencyEdit = new System.Windows.Forms.TextBox();
            this.landabeCheck = new System.Windows.Forms.CheckBox();
            this.label10 = new System.Windows.Forms.Label();
            this.runwayEdit = new System.Windows.Forms.TextBox();
            this.label11 = new System.Windows.Forms.Label();
            this.lenghtEdit = new System.Windows.Forms.TextBox();
            this.label12 = new System.Windows.Forms.Label();
            this.surfaceCombo = new System.Windows.Forms.ComboBox();
            this.label13 = new System.Windows.Forms.Label();
            this.commentEdit = new System.Windows.Forms.TextBox();
            this.label14 = new System.Windows.Forms.Label();
            this.shortName = new System.Windows.Forms.TextBox();
            this.checkBoxHomePoint = new System.Windows.Forms.CheckBox();
            this.latEdit = new SoaringDotNET.Controls.CoordEditControl();
            this.lonEdit = new SoaringDotNET.Controls.CoordEditControl();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(33, 19);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(35, 13);
            this.label1.TabIndex = 0;
            this.label1.Text = "Name";
            // 
            // name
            // 
            this.name.Location = new System.Drawing.Point(74, 16);
            this.name.Name = "name";
            this.name.Size = new System.Drawing.Size(218, 20);
            this.name.TabIndex = 0;
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(25, 136);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(45, 13);
            this.label2.TabIndex = 3;
            this.label2.Text = "Latitude";
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(175, 136);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(54, 13);
            this.label3.TabIndex = 4;
            this.label3.Text = "Longitude";
            // 
            // buttonOK
            // 
            this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.buttonOK.Location = new System.Drawing.Point(161, 314);
            this.buttonOK.Name = "buttonOK";
            this.buttonOK.Size = new System.Drawing.Size(75, 23);
            this.buttonOK.TabIndex = 14;
            this.buttonOK.Text = "&OK";
            // 
            // buttonCancel
            // 
            this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.buttonCancel.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.buttonCancel.Location = new System.Drawing.Point(255, 314);
            this.buttonCancel.Name = "buttonCancel";
            this.buttonCancel.Size = new System.Drawing.Size(75, 23);
            this.buttonCancel.TabIndex = 15;
            this.buttonCancel.Text = "&Cancel";
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(38, 175);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(32, 13);
            this.label4.TabIndex = 7;
            this.label4.Text = "ICAO";
            // 
            // icaoEdit
            // 
            this.icaoEdit.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
            this.icaoEdit.Location = new System.Drawing.Point(74, 173);
            this.icaoEdit.Name = "icaoEdit";
            this.icaoEdit.Size = new System.Drawing.Size(72, 20);
            this.icaoEdit.TabIndex = 7;
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(6, 57);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(60, 13);
            this.label5.TabIndex = 9;
            this.label5.Text = "Description";
            // 
            // descriptionEdit
            // 
            this.descriptionEdit.Location = new System.Drawing.Point(74, 55);
            this.descriptionEdit.Name = "descriptionEdit";
            this.descriptionEdit.Size = new System.Drawing.Size(406, 20);
            this.descriptionEdit.TabIndex = 1;
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(279, 96);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(31, 13);
            this.label6.TabIndex = 11;
            this.label6.Text = "Type";
            // 
            // typeCombo
            // 
            this.typeCombo.Location = new System.Drawing.Point(313, 94);
            this.typeCombo.Name = "typeCombo";
            this.typeCombo.Size = new System.Drawing.Size(167, 21);
            this.typeCombo.TabIndex = 3;
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(26, 96);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(43, 13);
            this.label7.TabIndex = 13;
            this.label7.Text = "Country";
            // 
            // countryCombo
            // 
            this.countryCombo.Location = new System.Drawing.Point(74, 94);
            this.countryCombo.Name = "countryCombo";
            this.countryCombo.Size = new System.Drawing.Size(167, 21);
            this.countryCombo.TabIndex = 2;
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(330, 136);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(68, 13);
            this.label8.TabIndex = 15;
            this.label8.Text = "Elevation (m)";
            // 
            // elevationEdit
            // 
            this.elevationEdit.Location = new System.Drawing.Point(395, 134);
            this.elevationEdit.Name = "elevationEdit";
            this.elevationEdit.Size = new System.Drawing.Size(85, 20);
            this.elevationEdit.TabIndex = 6;
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Location = new System.Drawing.Point(172, 175);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(57, 13);
            this.label9.TabIndex = 17;
            this.label9.Text = "Frequency";
            // 
            // frequencyEdit
            // 
            this.frequencyEdit.Location = new System.Drawing.Point(233, 173);
            this.frequencyEdit.Name = "frequencyEdit";
            this.frequencyEdit.Size = new System.Drawing.Size(79, 20);
            this.frequencyEdit.TabIndex = 8;
            // 
            // landabeCheck
            // 
            this.landabeCheck.Location = new System.Drawing.Point(325, 171);
            this.landabeCheck.Name = "landabeCheck";
            this.landabeCheck.Size = new System.Drawing.Size(104, 24);
            this.landabeCheck.TabIndex = 9;
            this.landabeCheck.Text = "Landable";
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Location = new System.Drawing.Point(25, 214);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(46, 13);
            this.label10.TabIndex = 20;
            this.label10.Text = "Runway";
            // 
            // runwayEdit
            // 
            this.runwayEdit.Location = new System.Drawing.Point(74, 212);
            this.runwayEdit.Name = "runwayEdit";
            this.runwayEdit.Size = new System.Drawing.Size(72, 20);
            this.runwayEdit.TabIndex = 10;
            // 
            // label11
            // 
            this.label11.AutoSize = true;
            this.label11.Location = new System.Drawing.Point(172, 214);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(57, 13);
            this.label11.TabIndex = 22;
            this.label11.Text = "Length (m)";
            // 
            // lenghtEdit
            // 
            this.lenghtEdit.Location = new System.Drawing.Point(233, 212);
            this.lenghtEdit.Name = "lenghtEdit";
            this.lenghtEdit.Size = new System.Drawing.Size(79, 20);
            this.lenghtEdit.TabIndex = 11;
            // 
            // label12
            // 
            this.label12.AutoSize = true;
            this.label12.Location = new System.Drawing.Point(328, 214);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(44, 13);
            this.label12.TabIndex = 24;
            this.label12.Text = "Surface";
            // 
            // surfaceCombo
            // 
            this.surfaceCombo.Location = new System.Drawing.Point(376, 212);
            this.surfaceCombo.Name = "surfaceCombo";
            this.surfaceCombo.Size = new System.Drawing.Size(104, 21);
            this.surfaceCombo.TabIndex = 12;
            // 
            // label13
            // 
            this.label13.AutoSize = true;
            this.label13.Location = new System.Drawing.Point(17, 253);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(51, 13);
            this.label13.TabIndex = 1;
            this.label13.Text = "Comment";
            // 
            // commentEdit
            // 
            this.commentEdit.Location = new System.Drawing.Point(74, 251);
            this.commentEdit.Name = "commentEdit";
            this.commentEdit.Size = new System.Drawing.Size(406, 20);
            this.commentEdit.TabIndex = 13;
            // 
            // label14
            // 
            this.label14.AutoSize = true;
            this.label14.Location = new System.Drawing.Point(315, 18);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(61, 13);
            this.label14.TabIndex = 25;
            this.label14.Text = "Short name";
            // 
            // shortName
            // 
            this.shortName.Location = new System.Drawing.Point(380, 16);
            this.shortName.Name = "shortName";
            this.shortName.ReadOnly = true;
            this.shortName.Size = new System.Drawing.Size(100, 20);
            this.shortName.TabIndex = 26;
            // 
            // checkBoxHomePoint
            // 
            this.checkBoxHomePoint.Image = ((System.Drawing.Image)(resources.GetObject("checkBoxHomePoint.Image")));
            this.checkBoxHomePoint.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.checkBoxHomePoint.Location = new System.Drawing.Point(74, 285);
            this.checkBoxHomePoint.Name = "checkBoxHomePoint";
            this.checkBoxHomePoint.Size = new System.Drawing.Size(99, 31);
            this.checkBoxHomePoint.TabIndex = 27;
            this.checkBoxHomePoint.Text = "Homepoint";
            this.checkBoxHomePoint.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
            // 
            // latEdit
            // 
            this.latEdit.IsLatitude = true;
            this.latEdit.Location = new System.Drawing.Point(74, 134);
            this.latEdit.Name = "latEdit";
            this.latEdit.Size = new System.Drawing.Size(72, 20);
            this.latEdit.TabIndex = 4;
            this.latEdit.Value = 0;
            // 
            // lonEdit
            // 
            this.lonEdit.IsLatitude = false;
            this.lonEdit.Location = new System.Drawing.Point(233, 134);
            this.lonEdit.Name = "lonEdit";
            this.lonEdit.Size = new System.Drawing.Size(79, 20);
            this.lonEdit.TabIndex = 5;
            this.lonEdit.Value = 0;
            // 
            // WaypointDialog
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(491, 348);
            this.Controls.Add(this.buttonOK);
            this.Controls.Add(this.checkBoxHomePoint);
            this.Controls.Add(this.shortName);
            this.Controls.Add(this.label14);
            this.Controls.Add(this.commentEdit);
            this.Controls.Add(this.label13);
            this.Controls.Add(this.label12);
            this.Controls.Add(this.lenghtEdit);
            this.Controls.Add(this.label11);
            this.Controls.Add(this.runwayEdit);
            this.Controls.Add(this.label10);
            this.Controls.Add(this.frequencyEdit);
            this.Controls.Add(this.label9);
            this.Controls.Add(this.elevationEdit);
            this.Controls.Add(this.label8);
            this.Controls.Add(this.label7);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.descriptionEdit);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.icaoEdit);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.name);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.surfaceCombo);
            this.Controls.Add(this.landabeCheck);
            this.Controls.Add(this.countryCombo);
            this.Controls.Add(this.typeCombo);
            this.Controls.Add(this.buttonCancel);
            this.Controls.Add(this.latEdit);
            this.Controls.Add(this.lonEdit);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "WaypointDialog";
            this.ShowInTaskbar = false;
            this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "Waypoint";
            this.ResumeLayout(false);
            this.PerformLayout();

        }
		#endregion

    }
}
